Attribute VB_Name = "modMain"
Option Explicit

Public Function CreateCommandFile(sGUID As String, sFrom As String, sTo As String)
    
    ' We need to put the message in the Inbound Queue of the Postoffice Connector
    
    Dim SpoolingCommandFileName As String
    Dim oFSO
    Dim oTS
    
    Set oFSO = CreateObject("Scripting.FileSystemObject")
    
    SpoolingCommandFileName = GetQueueDirectory() & "\SMTP\Outgoing\" & sGUID & ".MAI"
    
    Set oTS = oFSO.OpenTextFile(SpoolingCommandFileName, 2, True)
    
    oTS.WriteLine "CommandType=NORMAL"
    oTS.WriteLine "Recipients=[SMTP:" & sTo & "]"
    oTS.WriteLine "Sender=[SMTP:" & sFrom & "]"
    oTS.WriteLine "Retries=0"
    
    'the TimeAcquired is tricky if you are putting in the outbound queue
    'Due to how the SMTP service checks the dates, it may not be sent.
    'If you aren't sending much email, its easier to put in the Inbound directory
    'Below are the checks that are done
    oTS.WriteLine "TimeAcquired=" & DateDiff("s", #1/1/1970#, LocalToUTC(Now()))
    oTS.WriteLine "NextSendTime=" & DateDiff("s", #1/1/1970#, LocalToUTC(Now()))
    oTS.WriteLine "MessageID=" & sGUID & ".MAI"
    oTS.WriteLine "Priority=Normal"
    oTS.WriteLine "Status=UnSent"
    oTS.Close
    
    Set oTS = Nothing
    Set oFSO = Nothing
        
End Function


Public Function GetQueueDirectory() As String
    
    GetQueueDirectory = GetRegistryString("SOFTWARE\Mail Enable\Mail Enable\Connectors", "Connector Root Directory")

End Function


